=== debian/changelog ===
ros-crystal-fastrtps (1.7.2-0bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 27 Mar 2019 13:23:20 -0000
